package com.persagy.apm.energyalarmstarter.alarmengine.netty;

import com.alibaba.fastjson.JSONObject;
import com.alibaba.fastjson.annotation.JSONField;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;

import java.util.List;

/**
 * @description: netty报警消息格式定义
 * @author: lixing
 * @company: Persagy Technology Co.,Ltd
 * @since: 2020/11/30 10:52 上午
 * @version: V1.0
 */
@Getter
@Setter
@NoArgsConstructor
public class NettyAlarmMessage<T> {
    /**
     * 唯一标识
     */
    @JSONField()
    private long streamId;
    @JSONField()
    private int version = 1;

    @JSONField()
    private NettyMsgTypeEnum opCode;

    /**
     * 请求来源
     */
    @JSONField()
    private String source = "group";

    /**
     * 用于项目控制程序清除之前的时间和命令
     */
    @JSONField()
    private String clearBeforeTimeFlag;

    /**
     * 传输内容
     */
    @JSONField(jsonDirect = true)
    private List<T> content;

    /**
     * 成功标识
     */
    @JSONField()
    private Boolean success;

    @Override
    public String toString() {
        return JSONObject.toJSONString(this);
    }

    public NettyAlarmMessage(NettyMsgTypeEnum opCode, List<T> content) {
        this.opCode = opCode;
        this.content = content;
    }
}
